<control-multy-select style="min-height: 46px">
	<div class="multy-select { opts.vertical == 'true' ? 'vertical' : '' }" id="{ state.control_id }">

		<div class="selected-items" show="{ state.items.length }">
			<span class="item" each="{ item, index in state.items }">
				{ item.title }
				<a href="#" class="delete" onclick="{ delete_item }" title="αφαίρεση">&times;</a>
			</span>
		</div>

		<div class="select-input-group">

			<input type="text" data-ref="term" placeholder="{ opts.placeholder }" onkeyup="{ input_change }" onfocus="{ input_focus }">

			<a href="#" class="btn-dropdown" if="{ state.display_dropdown }" onclick="{ toggle_dropdown }">
				<i class="fa fa-angle-down"></i>
			</a>
			<a href="/page/locations-help" target="_blank" class="btn-help" title="{ state.source == 'locations' ? 'Βοήθεια για τις περιοχές' : '' }" if="{ state.source == 'locations' && state.show_help_button }">
				<i class="fa fa-info-circle"></i>
			</a>

			<loader-icon class="input-loader" if="{ state.loading }" style="{ state.display_dropdown || state.show_help_button ? 'right: 40px;' : '' }"></loader-icon>

			<div class="no-results" title="δεν βρέθηκαν αποτελέσματα!" style="{ state.display_dropdown || state.show_help_button ? 'right: 40px;' : '' }" if="{ state.no_results }">
				<i class="fa fa-exclamation-triangle"></i>
			</div>

		</div>

		<ul class="dropdown-results" if="{ state.search_results.length }">
			<li each="{ result in state.search_results }">
				<a href="#" onclick="{ search_result_select }">{ result.path }</a>
			</li>
		</ul>

		<ul class="dropdown-select" show="{ state.show_dropdown }">
			<li each="{ level0 in state.dropdown }">
				<a href="#" class="{ level0.expanded ? 'expanded' : '' }" onclick="{ toggle_dropdown_children }" if="{ level0.children.length }">
					{ level0.title }
					<span class="toggle-icon">
						<span if="{ !level0.expanded }"><i class="fa fa-caret-right"></i></span>
						<span if="{ level0.expanded }"><i class="fa fa-caret-down"></i></span>
					</span>
				</a>
				<a href="#" class="{ level0.expanded ? 'expanded' : '' }" onclick="{ select_dropdown_item }"  if="{ !level0.children.length }">
					{ level0.title }
				</a>
				<ul if="{ level0.children.length && level0.expanded }">
					<li if="{ level0.parent_id > 0 }">
						<a href="#" onclick="{ select_dropdown_item }" class="view-all">Όλα</a>
					</li>
					<li each="{ level1 in level0.children }">
						<a href="#" onclick="{ select_dropdown_item }">{ level1.title }</a>
						<ul if="{ level1.children.length }">
							<li each="{ level2 in level1.children }">
								<a href="#" onclick="{ select_dropdown_item }">{ level2.title }</a>
							</li>
						</ul>
					</li>
				</ul>
			</li>
		</ul>

	</div>

	<script>
	/*
		Methods:
		set_root ( root id ) :: sets the id of the root object
		get_values( [array key] ) :: returns the array of the specified key of all selected items
		get_first_slug() :: returns the slug of the item on index 0
		set_values( array with ids ) :: sets the initial items to display as selected

		Events:
		oninitialize() :: triggers when the constrol has been initalized
		onchangehandler() :: triggers when an item is added or removed from the selected items

		Opts:
		source :: the name of the source table to load results
		root :: the id of the parent object in source table
		dropdown :: "true" = dysplay the dropdown menu (dropdown-select)
		placeholder :: what to display on input placeholder
		vertical :: "true" = display control in vertical order
		showhelp :: "true" = display help link on input control
	*/

		this.timer = null;

		this.state = {
			control_id: "musel" + guidGenerator(), // create unique id for control
			source: this.opts.source,
			root_id: this.opts.root,
			show_help_button: this.opts.showhelp == "true",

			items: [],
			dropdown: [],
			search_results: [],

			display_dropdown: this.opts.dropdown == 'true',
			show_dropdown: false,
			no_results: false,
			loading: false,
		}


		this.set_root = (id, clear_selected) => {
			if (typeof clear_selected == 'undefined') {
				var clear_selected = true;
			}

			if (this.state.root_id != id && clear_selected) {
				// clear all items if same root id
				this.state.items = [];
				this.state.dropdown = [];
				this.set_controls();
			}
			this.state.root_id = id;
		}


		this.set_values = values => {
			if (values) {
				var tag = this;
				request(
					'multyselect_initialize',
					{
						'source': this.state.source,
						'values': values,
					},
					function(result) {
						if (result.items) {
							tag.state.items = result.items;
							tag.set_controls();

							if (tag.opts.oninitialize) {
								tag.opts.oninitialize();
							}
						}
					}, null, this.toggle_loader
				);
			}
		}


		this.get_values = key => {
			if (typeof key === 'undefined') {
				key = 'id';
			}
			var array = [];
			this.state.items.map( item => {
				array.push(item[key]);
			});
			return array;
		}


		this.get_first_slug = () => {
			return this.state.items[0].slug;
		}


		this.clear = () => {
			this.state.items = [];
			if (this.opts.onchangehandler) {
				this.opts.onchangehandler();
			}

			this.set_controls();
		}


		this.toggle_loader = value => {
			this.state.loading = value;
			this.update();
		}


		this.add_item = (id, title, slug, parent_id, root_id) => {

			// remove root category from items (works only for categories)
			var index = this.state.items.map(function(e) { return e.id }).indexOf(this.state.root_id);
			if (index > -1) {
				this.state.items.splice(index, 1);
			}		

			// check if item exist
			var item = this.state.items.find( x => x.id == id);
			if (!item) {
				
				// check if item root id exist in state.items (works only for locations)
				if (typeof root_id !== undefined) {
					var index = this.state.items.map(function(e) { return e.id }).indexOf(root_id);
					if (index > -1) {
						this.state.items.splice(index, 1);
					}
				}

				// check if items parent_id exist in state.items
				var index = this.state.items.map(function(e) { return e.id }).indexOf(parent_id);
				if (index > -1) {
					this.state.items.splice(index, 1);
				}

				// check if sub items exist and remove them
				var index = 0;
				while(index > -1) {
					index = this.state.items.map(function(e) { return e.parent_id }).indexOf(id);
					if (index > -1) {
						this.state.items.splice(index, 1);
					}
				}

				if (this.opts.source == 'locations' && parent_id == 0) {
					// remove all items with root_id == id
					var index = 0;
					while(index > -1) {
						index = this.state.items.map(function(e) { return e.root_id }).indexOf(id);
						if (index > -1) {
							this.state.items.splice(index, 1);
						}
					}
				}

				this.state.items.push({
					'id': id,
					'title': title,
					'slug': slug,
					'parent_id': parent_id,
					'root_id': root_id,
				});

				if (this.opts.onchangehandler) {
					this.opts.onchangehandler();
				}

				this.set_controls();
			}
		}


		this.delete_item = event => {
			event.preventDefault();

			this.state.items.splice(event.item.index, 1);
			this.set_controls();

			if (this.opts.onchangehandler) {
				this.opts.onchangehandler();
			}
		}


		this.search_items = term => {
			this.state.no_results = false;
			this.update();

			var tag = this;
			request(
				'multyselect_search',
				{
					'source': this.state.source,
					'root_id': this.state.root_id,
					'term': term
				},
				function(result) {
					tag.state.search_results = result.items;
					tag.state.no_results = result.items.length == 0;
					tag.update();
				}, null, this.toggle_loader
			);
		}


		this.search_result_select = event => {
			event.preventDefault();

			this.add_item(event.item.result.id, event.item.result.title, event.item.result.slug, event.item.result.parent_id, event.item.result.root_id);
			
			this.state.search_results = [];
			this.refs.term.value = "";

			this.set_controls();
		}


		this.input_change = event => {
			this.state.search_results = [];
			this.state.no_results = false;

			if (this.timer) {
				this.state.searching = false;
				clearTimeout(this.timer);
			}

			var term = event.target.value.trim();
			if (term.length > 2) {
				this.state.searching = true;
			
				var tag = this;
				this.timer = setTimeout(function() {
					clearTimeout(tag.timer);
					tag.search_items(term);
				}, 1000);
			}

		}


		this.input_focus = event => {
			this.state.show_dropdown = false;
		}


		/* control dropdown handlers */

		this.load_dropdown_items = () => {
			var tag = this;
			request(
				'multyselect_dropdown_load',
				{
					'source': this.state.source,
					'root_id': this.state.root_id,
				},
				function(result) {
					tag.state.dropdown = result.dropdown;
					tag.state.show_dropdown = true;

					tag.update();
				}, null, this.toggle_loader
			);
		}


		this.toggle_dropdown = event => {
			event.preventDefault();

			if (!this.state.show_dropdown && this.state.dropdown.length == 0) {
				// load items to display in dropdown menu
				this.load_dropdown_items();
			} else {
				this.state.show_dropdown = !this.state.show_dropdown;
			}
		}


		this.toggle_dropdown_children = event => {
			event.preventDefault();
			event.stopPropagation();

			// shrink all other expanded items
			this.state.dropdown.map ( item => {
				if (item.expanded && item.id != event.item.level0.id) {
					item.expanded = false;
				}
			});

			event.item.level0.expanded = !event.item.level0.expanded;
		}


		this.select_dropdown_item = event => {
			event.preventDefault();

			var item = null;
			if (event.item.level0) {
				item = event.item.level0;
			} else if (event.item.level1) {
				item = event.item.level1;
			} else if (event.item.level2) {
				item = event.item.level2;
			} else if (event.item.level3) {
				item = event.item.level3;
			}

			this.add_item(item.id, item.title, item.slug, item.parent_id, item.root_id);

			this.state.show_dropdown = false;

			// scroll the screen back to "multy-select"
			$('html,body').animate({ scrollTop: $(event.target).closest('.multy-select').offset().top - 100 });
		}


		/* control display handlers */

		this.set_controls = () => {
			this.update();

			if (this.opts.vertical != 'true' && Device != 'xs') {
				if (this.state.items.length > 0) {
					$('#' + this.state.control_id + ' .select-input-group').css('width', ($('#' + this.state.control_id).innerWidth() - $('#' + this.state.control_id + ' .selected-items').outerWidth() - 12) + 'px' );
				} else {
					$('#' + this.state.control_id + ' .select-input-group').css('width', '100%');
				}
			}

			if (this.state.items.length) {
				// set item:hover events
				$('.delete').hover(
					function() {
						$(this).closest('.item').addClass("to-remove")
					}, function() {
						$(this).closest('.item').removeClass("to-remove")
					}
				)
			}
		}


		this.on("mount", function() {
			this.set_controls();
		});
	</script>
</control-multy-select>